Imports Outlook = Microsoft.Office.Interop.Outlook
Imports Office = Microsoft.Office.Core
Imports System.Windows.Forms
Imports System.Diagnostics
Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.Runtime.InteropServices
Imports stdole

Friend Class ExplWrap
    Private WithEvents m_objExpl As Outlook.Explorer

    Private m_ID As Integer

    Private m_blnStartup As Boolean

    Private m_blnKilled As Boolean

    Private WithEvents m_button As Office.CommandBarButton

    Private m_pop As Office.CommandBarPopup

    Public Property Explorer() As Outlook.Explorer
        Get
            Return m_objExpl
        End Get

        Set(ByVal value As Outlook.Explorer)
            m_objExpl = value
            m_blnStartup = True
        End Set
    End Property


    Public Property Key() As Integer
        Get
            Return m_ID
        End Get

        Set(ByVal value As Integer)
            m_ID = value
        End Set
    End Property

    Public Sub New()
        m_blnKilled = False

        Try
            m_objExpl = Nothing
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub m_objExpl_Activate() Handles m_objExpl.Activate
        DoStartup()
    End Sub

    Private Sub m_objExpl_SelectionChange() Handles m_objExpl.SelectionChange
        DoStartup()
    End Sub

    Private Sub DoStartup()
        If (m_blnStartup = True) Then
            If (m_button Is Nothing) Then
                Try
                    Dim bar As Office.CommandBar = m_objExpl.CommandBars.Item("Menu Bar")
                    ' change the UI and Tag strings for your own addin
                    Dim idMenu As String = "ExplTestMenu" & Key.ToString()
                    Dim id As String = "ExplTestButton" & Key.ToString()

                    Dim Style As Office.MsoButtonStyle = Office.MsoButtonStyle.msoButtonIconAndCaption

                    Dim buttonMaker As CommandBarsMaker = New CommandBarsMaker()

                    ' change the UI and Tag strings for your own addin
                    m_pop = buttonMaker.NewMenu(bar, "VSTO_VBOutlookTemplate", idMenu, True, g_ProgID, True, "Custom Menu", True)

                    If m_pop IsNot Nothing Then
                        ' change the UI and Tag strings for your own addin
                        m_button = buttonMaker.NewButton(m_pop.CommandBar, "Test Button", id, True, g_ProgID, Style, False, "Test", True)

                        If (m_button IsNot Nothing) Then

                            ' add an icon to the button
                            Dim imgStreamPic As System.Drawing.Image
                            Dim oPic As IPictureDisp = Nothing
                            Dim ax As MyAxHost = New MyAxHost()

                            imgStreamPic = My.Resources.INFO.ToBitmap()

                            oPic = ax.IPictureDispFromImage(imgStreamPic)
                            m_button.Picture = oPic

                            imgStreamPic = Nothing
                            ax = Nothing
                            oPic = Nothing
                        End If

                        bar = Nothing
                    End If
                Catch ex As Exception
                    MessageBox.Show(ex.Message)
                End Try
            End If

            m_blnStartup = False
        End If
    End Sub
    Private Sub m_objExpl_Close() Handles m_objExpl.Close
        If Not m_blnKilled Then
            m_blnKilled = True
            KillExpl(m_ID)

            If m_objExpl IsNot Nothing Then
                m_button = Nothing
                m_objExpl = Nothing
            End If
        End If
    End Sub

    Private Sub m_button_Click(ByVal Ctrl As Microsoft.Office.Core.CommandBarButton, ByRef CancelDefault As Boolean) Handles m_button.Click
        MessageBox.Show(Ctrl.Caption & " clicked.")
    End Sub
End Class
