Imports Office = Microsoft.Office.Core
Imports Outlook = Microsoft.Office.Interop.Outlook

Friend Class InspWrap
    Public HTML As Boolean
    Public PT As Boolean
    Public RTF As Boolean

    Private WithEvents m_objInsp As Outlook.Inspector
    Private WithEvents m_objMail As Outlook.MailItem
    Private WithEvents m_objAppt As Outlook.AppointmentItem

    Private m_Region As TimeTravelFormRegionWrapper

    Private WithEvents m_Pane As Office.CustomTaskPane
    Private m_Ribbon As Ribbon

    Private m_ID As Integer
    Private m_blnKilled As Boolean

    Private m_Startup As Boolean

    Public Property Ribbon() As Ribbon
        Get
            Return m_Ribbon
        End Get

        Set(ByVal value As Ribbon)
            m_Ribbon = value
        End Set
    End Property

    Public Property TaskPane() As Office.CustomTaskPane
        Get
            Return m_Pane
        End Get

        Set(ByVal value As Office.CustomTaskPane)
            m_Pane = value
        End Set
    End Property

    Public Property Region() As TimeTravelFormRegionWrapper
        Get
            Return m_Region
        End Get

        Set(ByVal value As TimeTravelFormRegionWrapper)
            m_Region = value
        End Set
    End Property

    Public Property MailItem() As Outlook.MailItem
        Get
            Return m_objMail
        End Get

        Set(ByVal value As Outlook.MailItem)
            m_objMail = value
        End Set
    End Property

    Public Property AppointmentItem() As Outlook.AppointmentItem
        Get
            Return m_objAppt
        End Get

        Set(ByVal value As Outlook.AppointmentItem)
            m_objAppt = value
        End Set
    End Property

    Public Property Inspector() As Outlook.Inspector
        Get
            Return m_objInsp
        End Get

        Set(ByVal value As Outlook.Inspector)
            m_objInsp = value

            m_Startup = True
        End Set
    End Property

    Public Property Key() As Integer
        Get
            Return m_ID
        End Get

        Set(ByVal value As Integer)
            m_ID = value
        End Set
    End Property

    Private Sub m_objInsp_Activate() Handles m_objInsp.Activate
        If m_Startup Then
            If m_objMail IsNot Nothing Then
                Select Case m_objMail.BodyFormat
                    Case Outlook.OlBodyFormat.olFormatHTML
                        HTML = True
                        PT = False
                        RTF = False
                    Case Outlook.OlBodyFormat.olFormatPlain
                        HTML = False
                        PT = True
                        RTF = False
                    Case Outlook.OlBodyFormat.olFormatRichText
                        HTML = False
                        PT = False
                        RTF = True
                    Case Else
                        HTML = True
                        PT = False
                        RTF = False
                End Select

                If (m_Ribbon IsNot Nothing) Then
                    m_Ribbon.m_Ribbon.Invalidate()

                    m_Startup = False
                End If
            End If
        End If
    End Sub

    Private Sub m_objInsp_Close() Handles m_objInsp.Close
        If Not m_blnKilled Then
            m_blnKilled = True
            KillInsp(m_ID)

            If m_objMail IsNot Nothing Then
                m_objMail = Nothing
            End If

            If m_objAppt IsNot Nothing Then
                m_objAppt = Nothing
            End If

            If m_objInsp IsNot Nothing Then
                m_objInsp = Nothing
            End If

            If m_Region IsNot Nothing Then
                m_Region = Nothing
            End If

            If m_Pane IsNot Nothing Then
                m_Pane.Delete()
                m_Pane = Nothing
            End If

            If m_Ribbon IsNot Nothing Then
                m_Ribbon = Nothing
            End If

        End If
    End Sub

    Private Sub m_objMail_Close(ByRef Cancel As Boolean) Handles m_objMail.Close

    End Sub

    Private Sub m_objMail_Open(ByRef Cancel As Boolean) Handles m_objMail.Open

    End Sub

    Private Sub m_objMail_Send(ByRef Cancel As Boolean) Handles m_objMail.Send

    End Sub

    Private Sub m_objMail_Write(ByRef Cancel As Boolean) Handles m_objMail.Write

    End Sub

    Private Sub m_objAppt_Close(ByRef Cancel As Boolean) Handles m_objAppt.Close

    End Sub

    Private Sub m_objAppt_Open(ByRef Cancel As Boolean) Handles m_objAppt.Open

    End Sub

    Private Sub m_Pane_DockPositionStateChange(ByVal CustomTaskPaneInst As Microsoft.Office.Core.CustomTaskPane) Handles m_Pane.DockPositionStateChange

    End Sub

    Private Sub m_Pane_VisibleStateChange1(ByVal CustomTaskPaneInst As Office.CustomTaskPane) Handles m_Pane.VisibleStateChange

    End Sub
End Class
