Imports System
Imports System.Collections.Generic
Imports System.Diagnostics
Imports System.IO
Imports System.Text
Imports System.Reflection
Imports System.Runtime.InteropServices
Imports System.Windows.Forms
Imports stdole
Imports System.Drawing
Imports Office = Microsoft.Office.Core
Imports Outlook = Microsoft.Office.Interop.Outlook
Imports Forms = Microsoft.Vbe.Interop.Forms

' TODO:
' This is an override of the RequestService method in the ThisAddIn class.
' To hook up your custom ribbon uncomment this code.

Partial Public Class ThisAddIn

    Private ribbon As Ribbon

    Private FormRegionWrapper As TimeTravelFormRegionWrapper

    Private TaskPaneWrapper As CTPWrapper
    ' change the strings for your own addin
    Private Const CTP_PROGID As String = "VSTO_VBOutlookTemplate.EmailTaskPane"

    Protected Overrides Function RequestService(ByVal serviceGuid As System.Guid) As Object
        If serviceGuid = GetType(Office.IRibbonExtensibility).GUID Then
            If ribbon Is Nothing Then
                ribbon = New Ribbon()
            End If
            Return ribbon
        ElseIf serviceGuid = GetType(Outlook.FormRegionStartup).GUID Then
            If FormRegionWrapper Is Nothing Then
                FormRegionWrapper = New TimeTravelFormRegionWrapper()
                Return FormRegionWrapper
            End If
        ElseIf serviceGuid = GetType(Office.ICustomTaskPaneConsumer).GUID Then
            If TaskPaneWrapper Is Nothing Then
                TaskPaneWrapper = New CTPWrapper()
                Return TaskPaneWrapper
            End If
        End If

        Return MyBase.RequestService(serviceGuid)
    End Function

End Class

<ComVisible(True)> _
    Public Class Ribbon
    Implements Office.IRibbonExtensibility

    'Ribbon UI object
    Public m_Ribbon As Office.IRibbonUI

    Public Sub New()
    End Sub

#Region "Ribbon Initializer"
    Function GetCustomUI(ByVal RibbonID As String) As String Implements Microsoft.Office.Core.IRibbonExtensibility.GetCustomUI
        'RibbonID indicates type of Inspector that is about to be displayed,
        '   valid RibbonID values are as follows:
        'Microsoft.Outlook.Mail.Read
        'Microsoft.Outlook.Mail.Compose
        'Microsoft.Outlook.MeetingRequest.Read
        'Microsoft.Outlook.MeetingRequest.Send
        'Microsoft.Outlook.Appointment
        'Microsoft.Outlook.Contact
        'Microsoft.Outlook.Journal
        'Microsoft.Outlook.Task
        'Microsoft.Outlook.DistributionList
        'Microsoft.Outlook.Report
        'Microsoft.Outlook.Resend
        'Microsoft.Outlook.Response.Read
        'Microsoft.Outlook.Response.Compose
        'Microsoft.Outlook.Response.CounterPropose
        'Microsoft.Outlook.RSS
        'Microsoft.Outlook.Post.Read
        'Microsoft.Outlook.Post.Compose
        'Microsoft.Outlook.Sharing.Read
        'Microsoft.Outlook.Sharing.Compose

        'In this sample only new mail Inspector is handled for a button.

        Select Case RibbonID
            Case "Microsoft.Outlook.Mail.Compose"
                ' Return the RibbonX markup stored as a resource in the project
                Return My.Resources.CustomRibbon
            Case Else
                Return String.Empty
        End Select
    End Function
#End Region

#Region "Ribbon Callbacks"
    Public Sub VB_Action(ByVal control As Office.IRibbonControl)
        Debug.Print("VB_Action")

        Dim myInsp As Outlook.Inspector = CType(control.Context, Outlook.Inspector)
        Dim oInspWrap As InspWrap = Nothing

        If (control.Id = "VSTOVB6") Then
            Try
                For Each oInspWrap In g_colInspWrap
                    If (oInspWrap.Inspector Is myInsp) Then
                        If oInspWrap.TaskPane IsNot Nothing Then
                            oInspWrap.TaskPane.Visible = True
                        End If
                    Else
                        If oInspWrap IsNot Nothing Then
                            oInspWrap.TaskPane.Visible = False
                        End If
                    End If
                Next
            Catch ex As Exception
                MessageBox.Show(ex.Message)
            End Try
        End If

        oInspWrap = Nothing
        myInsp = Nothing
    End Sub

    Public Sub VBToggle(ByVal control As Office.IRibbonControl, ByVal pressed As Boolean)
        Debug.Print("VBToggle")
        ' pressed is True if the new button state is On.

        Dim myInsp As Outlook.Inspector = CType(control.Context, Outlook.Inspector)
        Dim oInspWrap As InspWrap = Nothing

        Try
            For Each oInspWrap In g_colInspWrap
                If (oInspWrap.Inspector Is myInsp) Then
                    Select Case control.Id
                        Case "VSTOVB1"
                            oInspWrap.HTML = True
                            oInspWrap.PT = False
                            oInspWrap.RTF = False
                            oInspWrap.MailItem.BodyFormat = Outlook.OlBodyFormat.olFormatHTML
                            m_Ribbon.InvalidateControl("VSTOVB1")
                            m_Ribbon.InvalidateControl("VSTOVB2")
                            m_Ribbon.InvalidateControl("VSTOVB3")
                        Case "VSTOVB2"
                            oInspWrap.PT = True
                            oInspWrap.HTML = False
                            oInspWrap.RTF = False
                            oInspWrap.MailItem.BodyFormat = Outlook.OlBodyFormat.olFormatPlain
                            m_Ribbon.InvalidateControl("VSTOVB1")
                            m_Ribbon.InvalidateControl("VSTOVB2")
                            m_Ribbon.InvalidateControl("VSTOVB3")
                        Case "VSTOVB3"
                            oInspWrap.RTF = True
                            oInspWrap.HTML = False
                            oInspWrap.PT = False
                            oInspWrap.MailItem.BodyFormat = Outlook.OlBodyFormat.olFormatRichText
                            m_Ribbon.InvalidateControl("VSTOVB1")
                            m_Ribbon.InvalidateControl("VSTOVB2")
                            m_Ribbon.InvalidateControl("VSTOVB3")
                        Case Else
                    End Select
                End If
            Next
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

        oInspWrap = Nothing
        myInsp = Nothing
    End Sub

    Public Function VBPressed(ByVal control As Office.IRibbonControl) As Boolean
        Debug.Print("VB_GetPressed " & control.Id.ToString)

        Dim myInsp As Outlook.Inspector = CType(control.Context, Outlook.Inspector)
        Dim oInspWrap As InspWrap = Nothing

        Try
            For Each oInspWrap In g_colInspWrap
                If (oInspWrap.Inspector Is myInsp) Then
                    Select Case control.Id
                        Case "VSTOVB1"
                            Return oInspWrap.HTML
                        Case "VSTOVB2"
                            Return oInspWrap.PT
                        Case "VSTOVB3"
                            Return oInspWrap.RTF
                        Case Else
                    End Select
                End If
            Next
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

        oInspWrap = Nothing
        myInsp = Nothing
    End Function

    Public Function VB_GetImage(ByVal control As Office.IRibbonControl) As stdole.IPictureDisp
        Dim imgStreamPic As System.Drawing.Bitmap
        Dim oPic As IPictureDisp
        Dim ax As MyAxHost

        Select Case control.Id
            Case "VSTOVB1"
                imgStreamPic = My.Resources.BALLOON
            Case "VSTOVB2"
                imgStreamPic = My.Resources.BELL
            Case "VSTOVB3"
                imgStreamPic = My.Resources.CUP
            Case "VSTOVB4"
                imgStreamPic = My.Resources.ENVELOPE
            Case "VSTOVB6"
                imgStreamPic = My.Resources.KEY
            Case Else
                imgStreamPic = My.Resources.HAPPY
        End Select

        ax = New MyAxHost

        oPic = ax.IPictureDispFromImage(imgStreamPic)

        imgStreamPic = Nothing
        ax = Nothing

        Return oPic

    End Function

    Public Function VB_GetVisible(ByVal control As Office.IRibbonControl) As Boolean
        Debug.Print("VB_GetVisible")

        Return True

    End Function

    Public Function VB_GetLabel(ByVal control As Office.IRibbonControl) As String
        Debug.Print("VB_GetLabel")

        Dim Name As String = "Control_" & control.Id
        Return Name

    End Function

    Public Function VB_GetSuperTip(ByVal control As Office.IRibbonControl) As String
        Debug.Print("VB_GetSuperTip")

        Dim Name As String = "Tip_" & control.Id
        Return Name

    End Function

    Public Sub Ribbon_OnLoad(ByVal Ribbon As Office.IRibbonUI)
        Debug.Print("Ribbon_OnLoad")

        m_Ribbon = Ribbon

        Dim oInspWrap As InspWrap = Nothing

        For Each oInspWrap In g_colInspWrap
            If oInspWrap.Ribbon Is Nothing Then
                oInspWrap.Ribbon = m_Ribbon
            End If
        Next

        oInspWrap = Nothing
    End Sub
#End Region

#Region "Ribbon Properties"
    Friend ReadOnly Property Ribbon() As Office.IRibbonUI
        Get
            Return m_Ribbon
        End Get
    End Property
#End Region

End Class

Public Class MyAxHost
    Inherits System.Windows.Forms.AxHost

    Public Sub New()
        MyBase.New("{59EE46BA-677D-4d20-BF10-8D8067CB8B33}")
    End Sub

    Public Function IPictureDispFromImage(ByVal Image As System.Drawing.Image) As stdole.IPictureDisp
        Dim oPic As stdole.IPictureDisp

        oPic = CType(System.Windows.Forms.AxHost.GetIPictureDispFromPicture(Image), _
         stdole.IPictureDisp)

        Return oPic
    End Function
End Class

<ComVisible(True)> _
Public Class TimeTravelFormRegionWrapper
    ' required for Form Region support
    Implements Outlook.FormRegionStartup

#Region "Class Declarations"
    ' Form Region declarations
    ' change the strings for your own addin
    Private Const TIME_TRAVEL_FORM_REGION As String = "TimeTravel" ' use the value in the <name> tag in the Region XML
    Private WithEvents m_FormRegion As Outlook.FormRegion
    Private WithEvents m_Form As Forms.UserForm

    Private oAppt As Outlook.AppointmentItem

    Private TravelToStartDate As Outlook.OlkDateControl
    Private TravelToStartTime As Outlook.OlkTimeControl
    Private TravelToStartTimeZone As Outlook.OlkTimeZoneControl
    Private TravelToEndDate As Outlook.OlkDateControl
    Private TravelToEndTime As Outlook.OlkTimeControl
    Private TravelToEndTimeZone As Outlook.OlkTimeZoneControl
    Private ChkBillableTo As Outlook.OlkCheckBox

    Private TravelFromStartDate As Outlook.OlkDateControl
    Private TravelFromStartTime As Outlook.OlkTimeControl
    Private TravelFromStartTimeZone As Outlook.OlkTimeZoneControl
    Private TravelFromEndDate As Outlook.OlkDateControl
    Private TravelFromEndTime As Outlook.OlkTimeControl
    Private TravelFromEndTimeZone As Outlook.OlkTimeZoneControl
    Private ChkBillableFrom As Outlook.OlkCheckBox
#End Region

#Region "Initialization"
    Public Sub Init(ByVal Region As Outlook.FormRegion)
        m_FormRegion = Region
        oAppt = TryCast(Region.Item, Outlook.AppointmentItem)
        m_Form = CType(m_FormRegion.Form, Forms.UserForm)

        InitializeControls()
    End Sub

    Private Sub InitializeControls()
        Dim oZone As Outlook.TimeZone = Nothing

        Try
            TravelToStartDate = TryCast(m_Form.Controls.Item("olkTravelToStartDate"), Outlook.OlkDateControl)
            TravelToStartTime = TryCast(m_Form.Controls.Item("olkTravelToStartTime"), Outlook.OlkTimeControl)
            TravelToStartTimeZone = TryCast(m_Form.Controls.Item("olkTravelToStartTimeZone"), Outlook.OlkTimeZoneControl)
            TravelToEndDate = TryCast(m_Form.Controls.Item("olkTravelToEndDate"), Outlook.OlkDateControl)
            TravelToEndTime = TryCast(m_Form.Controls.Item("olkTravelToEndTime"), Outlook.OlkTimeControl)
            TravelToEndTimeZone = TryCast(m_Form.Controls.Item("olkTravelToEndTimeZone"), Outlook.OlkTimeZoneControl)
            ChkBillableTo = TryCast(m_Form.Controls.Item("olkChkBillableTo"), Outlook.OlkCheckBox)

            TravelFromStartDate = TryCast(m_Form.Controls.Item("olkTravelFromStartDate"), Outlook.OlkDateControl)
            TravelFromStartTime = TryCast(m_Form.Controls.Item("olkTravelFromStartTime"), Outlook.OlkTimeControl)
            TravelFromStartTimeZone = TryCast(m_Form.Controls.Item("olkTravelFromStartTimeZone"), Outlook.OlkTimeZoneControl)
            TravelFromEndDate = TryCast(m_Form.Controls.Item("olkTravelFromEndDate"), Outlook.OlkDateControl)
            TravelFromEndTime = TryCast(m_Form.Controls.Item("olkTravelFromEndTime"), Outlook.OlkTimeControl)
            TravelFromEndTimeZone = TryCast(m_Form.Controls.Item("olkTravelFromEndTimeZone"), Outlook.OlkTimeZoneControl)
            ChkBillableFrom = TryCast(m_Form.Controls.Item("olkChkBillableFrom"), Outlook.OlkCheckBox)

            oZone = g_objOL.TimeZones.CurrentTimeZone

            TravelToStartDate.Value = DateTime.Today
            TravelToStartTime.Value = DateTime.Now

            TravelToStartTimeZone.AppointmentTimeField = Outlook.OlAppointmentTimeField.olAppointmentTimeFieldNone
            TravelToStartTimeZone.Value = oZone

            TravelToEndDate.Value = DateTime.Today
            TravelToEndTime.Value = DateTime.Now

            TravelToEndTimeZone.AppointmentTimeField = Outlook.OlAppointmentTimeField.olAppointmentTimeFieldNone
            TravelToEndTimeZone.Value = oZone

            ChkBillableTo.Value = True

            TravelFromStartDate.Value = DateTime.Today
            TravelFromStartTime.Value = DateTime.Now

            TravelFromStartTimeZone.AppointmentTimeField = Outlook.OlAppointmentTimeField.olAppointmentTimeFieldNone
            TravelFromStartTimeZone.Value = oZone

            TravelFromEndDate.Value = DateTime.Today
            TravelFromEndTime.Value = DateTime.Now

            TravelFromEndTimeZone.AppointmentTimeField = Outlook.OlAppointmentTimeField.olAppointmentTimeFieldNone
            TravelFromEndTimeZone.Value = oZone

            ChkBillableFrom.Value = True

        Catch ex As Exception
            Debug.WriteLine(ex.Message)
        End Try

        oZone = Nothing
    End Sub
#End Region

#Region "Form Region Support"
    Function GetFormRegionIcon(ByVal FormRegionName As String, ByVal LCID As Integer, ByVal Icon As Microsoft.Office.Interop.Outlook.OlFormRegionIcon) As Object Implements Outlook.FormRegionStartup.GetFormRegionIcon
        Return Nothing
    End Function

    Function GetFormRegionManifest(ByVal FormRegionName As String, ByVal LCID As Integer) As Object Implements Outlook.FormRegionStartup.GetFormRegionManifest
        Return ""
    End Function

    Function GetFormRegionStorage(ByVal FormRegionName As String, ByVal Item As Object, ByVal LCID As Integer, ByVal FormRegionMode As Outlook.OlFormRegionMode, ByVal FormRegionSize As Outlook.OlFormRegionSize) As Object Implements Outlook.FormRegionStartup.GetFormRegionStorage
        ' FormRegionName is the name of the region being loaded, can be returned as an OFS file as a Resource or as an OFS file.
        ' Item is the Outlook item looking for the form region. Based on the registry entry for that MessageClass.
        ' LCID is the locale setting for internationalization usage
        ' FormRegionMode is either read, compose or preview
        ' FormRegionSize is either adjoining or separate
        Try
            If FormRegionName = TIME_TRAVEL_FORM_REGION Then
                ' return the name of the Resources file that's the Form Region OFS file
                Return My.Resources.TimeTravel
            Else
                ' if it's not for us return Nothing
                Return Nothing
            End If
        Catch ex As Exception
            Debug.WriteLine(ex.Message)
            Return Nothing
        End Try
    End Function

    Sub BeforeFormRegionShow(ByVal FormRegion As Outlook.FormRegion) Implements Outlook.FormRegionStartup.BeforeFormRegionShow
        m_FormRegion = FormRegion

        Dim wrap As InspWrap = Nothing

        For Each wrap In g_colInspWrap
            If wrap.Inspector Is FormRegion.Inspector Then
                wrap.Region.Init(FormRegion)
            End If
        Next

        wrap = Nothing
    End Sub
#End Region

#Region "Form Region Events"
    Private Sub m_FormRegion_Expanded(ByVal Expand As Boolean) Handles m_FormRegion.Expanded
        Debug.WriteLine("Form Region expanded")
    End Sub

    Private Sub m_FormRegion_Close() Handles m_FormRegion.Close

    End Sub
#End Region

End Class

<ComVisible(True)> _
Public Class CTPWrapper

    ' required for CTP use
    Implements Office.ICustomTaskPaneConsumer

    ' Task Pane declaration
    Public m_CTP As Office.ICTPFactory

    Public Sub CTPFactoryAvailable(ByVal CTPFactoryInst As Microsoft.Office.Core.ICTPFactory) Implements Microsoft.Office.Core.ICustomTaskPaneConsumer.CTPFactoryAvailable
        m_CTP = CTPFactoryInst
    End Sub

End Class