Imports Outlook = Microsoft.Office.Interop.Outlook
Imports Office = Microsoft.Office.Core
Imports System.Windows.Forms

Friend Module OutInsp
    Public Sub AddInsp(ByVal Inspector As Outlook.Inspector, _
    ByVal Pane As Office.CustomTaskPane, ByVal Region As TimeTravelFormRegionWrapper, _
    ByVal Ribbon As Ribbon)
        Dim objInspWrap As New InspWrap
        Dim oMail As Outlook.MailItem = Nothing
        Dim oAppt As Outlook.AppointmentItem = Nothing

        If (TypeOf (Inspector.CurrentItem) Is Outlook.MailItem) Then
            oMail = TryCast(Inspector.CurrentItem, Outlook.MailItem)
            If oMail IsNot Nothing Then
                Try
                    With objInspWrap
                        .Inspector = Inspector
                        .MailItem = oMail
                        .AppointmentItem = Nothing
                        .Region = Nothing
                        .Ribbon = Ribbon
                        .TaskPane = Pane

                        .Key = g_WrapperID
                    End With

                    g_colInspWrap.Add(objInspWrap, CStr(g_WrapperID))

                    g_WrapperID += 1

                Catch ex As Exception
                    MessageBox.Show(ex.Message)
                End Try
            End If
        ElseIf (TypeOf (Inspector.CurrentItem) Is Outlook.AppointmentItem) Then
            oAppt = TryCast(Inspector.CurrentItem, Outlook.AppointmentItem)
            If oAppt IsNot Nothing Then
                Try
                    With objInspWrap
                        .Inspector = Inspector
                        .MailItem = Nothing
                        .AppointmentItem = oAppt
                        .Region = Region
                        .Ribbon = Nothing
                        .TaskPane = Nothing

                        .Key = g_WrapperID
                    End With

                    g_colInspWrap.Add(objInspWrap, CStr(g_WrapperID))

                    g_WrapperID += 1

                Catch ex As Exception
                    MessageBox.Show(ex.Message)
                End Try
            End If
        End If

        objInspWrap = Nothing
        oMail = Nothing
        oAppt = Nothing
    End Sub


    Public Sub KillInsp(ByVal WrapperID As Integer)
        Try
            g_colInspWrap.Remove(CStr(WrapperID))
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

End Module
